#include <iostream>
#include <cstdlib>
#include <string>
using namespace std;

const int MAX_JOBS = 100; 

class Job
{
private:
	string name;
	int hour;
public:
	Job() { this->name = ""; this->hour = 0; }
	Job(string name, int hour) { this->name = name; this->hour = hour; }
	void setHour(int hour) { this->hour = hour; }
	string getName() { return this->name; }
	double getHour() { return this->hour; }
	void print();
};

void Job::print()
{
	cout << "(" << this->name << ", " << this->hour << ")";
}





class JobList
{
private: 
	Job jobs[MAX_JOBS];
	int count;
public:
	JobList() { this->count = 0; }
	int getCount() { return this->count; }
	bool insert(Job job, int index);
		// if index < 0 or this->count == MAX_JOBS, return false. 
		// if 0 <= index <= this->count, put job at jobs[index]. Return true.
		// if index > this->count, put job at jobs[this->count]. Return true. 
	Job remove(int index);
	void print();
};

bool JobList::insert(Job job, int index)
{
	if(index < 0 || this->count == MAX_JOBS)
		return false;
	else if(index > this->count)
		this->jobs[this->count] = job;
	else
	{
		for(int i = this->count - 1; i >= index; i--)
			this->jobs[i+1] = this->jobs[i];
		this->jobs[index] = job;
	}
	this->count++;
	return true;
}		

Job JobList::remove(int index)
{
	Job toRemove;
	if(index < 0 || this->count == 0)
		return toRemove;
	else if(index > this->count)
		toRemove = this->jobs[this->count];
	else
	{
		toRemove = this->jobs[index];
		for(int i = index; i < this->count - 1; i++)
			this->jobs[i] = this->jobs[i+1];
	}
	this->count--;
	return toRemove;
}

void JobList::print()
{
	for(int i = 0; i < this->count; i++)
	{
		cout << "Job " << i + 1 << ": ";
		this->jobs[i].print();
		cout << endl;
	}
}






int main()
{
	JobList l;
	
	Job j1("Programming", 2);
	Job j2("Sleep", 1);
	Job j3("Calculus", 3);
	l.insert(j1, 0);
	l.insert(j2, 1);
	l.insert(j3, 2);
	l.print();
	cout << endl;
	
	Job temp;
	temp = l.remove(1);
	temp.print();
	cout << " is removed" << endl;
	temp = l.remove(1);
	temp.print();
	cout << " is removed" << endl;
	
	cout << endl;
	l.print();
	cout << endl;
	
	return 0;
}
